Attribute VB_Name = "Module1"
Option Explicit

'A couple of global sprite references
Public sprTarget As Sprite
Public sprSight As Sprite

'A global to store key code information
Public giKeyStatus As Integer

'Flags for monitoring movement keys
Global Const KEY_CUR_LEFT_FLAG = 1
Global Const KEY_CUR_RIGHT_FLAG = 2
Global Const KEY_CUR_UP_FLAG = 4
Global Const KEY_CUR_DOWN_FLAG = 8
Global Const KEY_FIRE_FLAG = 16
Global Const KEY_STOP_FLAG = 32

'KeyCode values for important keys
'Note that movement has been mapped to the numeric keypad!
Global Const KEY_CUR_LEFT = 100     '4 key
Global Const KEY_CUR_UP = 104       '8 key
Global Const KEY_CUR_RIGHT = 102    '6 key
Global Const KEY_CUR_DOWN = 98      '2 key
Global Const KEY_CUR_DL = 97        '1 key
Global Const KEY_CUR_DR = 99        '3 key
Global Const KEY_CUR_UL = 103       '7 key
Global Const KEY_CUR_UR = 105       '9 key
Global Const KEY_STOP = 101         '5 Key
Global Const KEY_FIRE = 32          'SPACE bar
Global Const KEY_QUIT = 81          'Q key
Global Const KEY_START = 13         'ENTER key

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'API Constants & Types

'Constants for BitBlt() copy modes
Global Const SRCCOPY = &HCC0020
Global Const SRCAND = &H8800C6
Global Const SRCPAINT = &HEE0086
Global Const NOTSRCCOPY = &H330008
Global Const SRCERASE = &H440328
Global Const SRCINVERT = &H660046

'Constants for objects Scale Mode
'Global Const TWIPS = 1
'Global Const PIXELS = 3
'Global Const RES_INFO = 2
'Global Const MINIMIZED = 1

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'API Function Imports

'Windows resources functions for VB 4 & 5 users
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
'Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

'For use by the timer device direct from Windows!!!
Private mlTimer As Long
Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Any) As Long
Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long


Public Sub main()
Dim l As Long
Dim b As Boolean

'Load the main form
Load frmMain

'Initialise the target
Set sprTarget = New Sprite
With sprTarget
    b = .SetPicture(frmMain.picTarget, 0, 0, frmMain.picTarget.Width \ Screen.TwipsPerPixelX, frmMain.picTarget.Height \ Screen.TwipsPerPixelY)
    If b Then
        .bActive = True
        .MoveAbs 10, 10
    End If
End With

'Initialise the sight
Set sprSight = New Sprite
With sprSight
    b = .SetPicture(frmMain.picSight, 0, 0, frmMain.picSight.Width \ Screen.TwipsPerPixelX, frmMain.picSight.Height \ Screen.TwipsPerPixelY)
    If b Then
        .bActive = True
        .MoveAbs 100, 20
    End If
End With

'Show the form
frmMain.Show vbModal

'Make sure timer resource is released
StopTimer

'Make sure form is unloaded
Unload frmMain

End Sub

Public Sub StartTimer()

If mlTimer = 0 Then mlTimer = SetTimer(&O0, 0, 50, AddressOf ControlLoop)

End Sub

Public Sub StopTimer()

If mlTimer Then mlTimer = KillTimer(&O0, mlTimer)
mlTimer = 0

End Sub


Public Sub ControlLoop()
Dim lDC As Long
Dim lW As Long
Dim lH As Long
Dim lX As Long
Dim lY As Long
Static lDx As Long
Static lPlayerDx As Long
Static lPlayerDy As Long

'Initialise targets x velocity first time through
If lDx = 0 Then lDx = 5

'Get DC for destination form
lDC = frmMain.hdc

'Restore backgrounds
sprTarget.Restore lDC
sprSight.Restore lDC

'If fire key pressed check for collision
If giKeyStatus And KEY_FIRE_FLAG Then
    If sprTarget.bCollision(sprSight) Then
        'Yep, its a hit.  Just a quick end here for time being!
'        tmrControlLoop.Enabled = False
        StopTimer
        giKeyStatus = 0
        lPlayerDx = 0
        lPlayerDy = 0
        Exit Sub
    End If
End If

'Move Target sprite under computer control
'This is relativly simple ping-pong code and needs to be
'replaced with decent movement code, maybe AI?
lW = frmMain.ScaleWidth \ Screen.TwipsPerPixelX
If lDx > 0 Then
    If sprTarget.lXMax() + lDx > lW Then
        lDx = -1 * lDx
        lX = sprTarget.lX
    Else
        lX = sprTarget.lX + lDx
    End If
Else
    If sprTarget.lX + lDx < 0 Then
        lDx = -1 * lDx
        lX = 0
    Else
        lX = sprTarget.lX + lDx
    End If
End If
sprTarget.MoveRel lX - sprTarget.lX, 0

'Move sight under user control
If giKeyStatus And (KEY_CUR_LEFT_FLAG Or KEY_CUR_RIGHT_FLAG Or KEY_CUR_UP_FLAG Or KEY_CUR_DOWN_FLAG) Then
    lPlayerDx = 0
    lPlayerDy = 0
    If giKeyStatus And KEY_CUR_LEFT_FLAG Then lPlayerDx = -10
    If giKeyStatus And KEY_CUR_RIGHT_FLAG Then lPlayerDx = 10
    If giKeyStatus And KEY_CUR_UP_FLAG Then lPlayerDy = -10
    If giKeyStatus And KEY_CUR_DOWN_FLAG Then lPlayerDy = 10
End If
If giKeyStatus And KEY_STOP_FLAG Then
    lPlayerDx = 0
    lPlayerDy = 0
End If
giKeyStatus = 0
sprSight.MoveRel lPlayerDx, lPlayerDy

'Draw sprites
sprSight.Draw lDC
sprTarget.Draw lDC

'Refresh the display
frmMain.Refresh

End Sub

